SketchUp C API

- Main Page
- Related Pages
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Related Functions
SUDimensionRef Struct Reference

A dimension entity reference. More...

`#include <SketchUpAPI/model/dimension.h>`

Inherits SUDrawingElementRef.

Inherited by SUDimensionLinearRef, and SUDimensionRadialRef.

## Related Functions
(Note that these are not member functions.)
SUEntityRef | SUDimensionToEntity (SUDimensionRef dimension)
| Converts from an SUDimensionRef to an SUEntityRef. This is essentially an upcast operation. More...
SUDimensionRef | SUDimensionFromEntity (SUEntityRef entity)
| Converts from an SUEntityRef to an SUDimensionRef. This is essentially a downcast operation so the given SUEntityRef must be convertible to an SUDimensionRef. More...
SUDrawingElementRef | SUDimensionToDrawingElement (SUDimensionRef dimension)
| Converts from an SUDimensionRef to an SUDrawingElementRef. This is essentially an upcast operation. More...
SUDimensionRef | SUDimensionFromDrawingElement (SUDrawingElementRef element)
| Converts from an SUDrawingElementRef to an SUDimensionRef. This is essentially a downcast operation so the given SUDrawingElementRef must be convertible to an SUDimensionRef. More...
enum SUResult | SUDimensionGetType (SUDimensionRef dimension, enum SUDimensionType *type)
| Retrieves an enum value indicating the dimension type (linear or radial). More...
enum SUResult | SUDimensionGetText (SUDimensionRef dimension, SUStringRef *text)
| Retrieves the text of a dimension object. More...
enum SUResult | SUDimensionSetText (SUDimensionRef dimension, const char *text)
| Sets the text of a dimension object. More...
enum SUResult | SUDimensionGetPlane (SUDimensionRef dimension, struct SUPlane3D *plane)
| Retrieves the plane of a dimension object. More...
enum SUResult | SUDimensionGetText3D (SUDimensionRef dimension, bool *is_text_3d)
| Retrieves a boolean indicating if the dimension text is 3D. More...
enum SUResult | SUDimensionSetText3D (SUDimensionRef dimension, bool is_text_3d)
| Sets a boolean indicating whether the dimension text is 3D. More...
enum SUResult | SUDimensionGetArrowType (SUDimensionRef dimension, enum SUArrowType *type)
| Retrieves an enum value indicating the dimension's arrow type. More...
enum SUResult | SUDimensionSetArrowType (SUDimensionRef dimension, enum SUArrowType type)
| Sets the dimension's arrow type. More...
enum SUResult | SUDimensionGetFont (SUDimensionRef dimension, SUFontRef *font)
| Get the dimension's font reference. More...
enum SUResult | SUDimensionSetFont (SUDimensionRef dimension, SUFontRef font)
| Sets the dimension's font from a font reference. More...
Related Functions inherited from SUDrawingElementRef
SUEntityRef | SUDrawingElementToEntity (SUDrawingElementRef elem)
| Converts from an SUDrawingElementRef to an SUEntityRef. This is essentially an upcast operation. More...
SUDrawingElementRef | SUDrawingElementFromEntity (SUEntityRef entity)
| Converts from an SUEntityRef to an SUDrawingElementRef. This is essentially a downcast operation so the given entity must be convertible to a drawing element. More...
enum SURefType | SUDrawingElementGetType (SUDrawingElementRef elem)
| Returns the concrete type of the given drawing element. More...
enum SUResult | SUDrawingElementGetBoundingBox (SUDrawingElementRef elem, struct SUBoundingBox3D *bbox)
| Retrieves the bounding box of a drawing element. More...
enum SUResult | SUDrawingElementGetMaterial (SUDrawingElementRef elem, SUMaterialRef *material)
| Retrieves the material object of a drawing element. More...
enum SUResult | SUDrawingElementSetMaterial (SUDrawingElementRef elem, SUMaterialRef material)
| Sets the material of a drawing element. More...
enum SUResult | SUDrawingElementGetLayer (SUDrawingElementRef elem, SULayerRef *layer)
| Retrieves the layer object associated with a drawing element. More...
enum SUResult | SUDrawingElementSetLayer (SUDrawingElementRef elem, SULayerRef layer)
| Sets the layer object to be associated with a drawing element. More...
enum SUResult | SUDrawingElementSetHidden (SUDrawingElementRef elem, bool hide_flag)
| Sets the hide flag of a drawing element. More...
enum SUResult | SUDrawingElementGetHidden (SUDrawingElementRef elem, bool *hide_flag)
| Retrieves the hide flag of a drawing element. More...
enum SUResult | SUDrawingElementSetCastsShadows (SUDrawingElementRef elem, bool casts_shadows_flag)
| Sets the casts shadows flag of a drawing element. More...
enum SUResult | SUDrawingElementGetCastsShadows (SUDrawingElementRef elem, bool *casts_shadows_flag)
| Retrieves the casts shadows flag of a drawing element. More...
enum SUResult | SUDrawingElementSetReceivesShadows (SUDrawingElementRef elem, bool receives_shadows_flag)
| Sets the receives shadows flag of a drawing element. More...
enum SUResult | SUDrawingElementGetReceivesShadows (SUDrawingElementRef elem, bool *receives_shadows_flag)
| Retrieves the receives shadows flag of a drawing element. More...
Related Functions inherited from SUEntityRef
enum SURefType | SUEntityGetType (SUEntityRef entity)
| Returns the concrete type of the given entity. More...
enum SUResult | SUEntityGetID (SUEntityRef entity, int32_t *entity_id)
| Retrieves the id of the entity. More...
enum SUResult | SUEntityGetPersistentID (SUEntityRef entity, int64_t *entity_pid)
| Retrieves the persistent id of the entity. More...
enum SUResult | SUEntityGetNumAttributeDictionaries (SUEntityRef entity, size_t *count)
| Retrieves the number of attribute dictionaries of an entity. More...
enum SUResult | SUEntityGetAttributeDictionaries (SUEntityRef entity, size_t len, SUAttributeDictionaryRef dictionaries[], size_t *count)
| Retrieves the attribute dictionaries of an entity. More...
enum SUResult | SUEntityAddAttributeDictionary (SUEntityRef entity, SUAttributeDictionaryRef dictionary)
| Adds the attribute dictionary to an entity. The given dictionary object must not belong to another entity. In other words, each dictionary should be added to one entity only. More...
enum SUResult | SUEntityGetAttributeDictionary (SUEntityRef entity, const char *name, SUAttributeDictionaryRef *dictionary)
| Retrieves the attribute dictionary of an entity that has the given name. More...
enum SUResult | SUEntityGetModel (SUEntityRef entity, SUModelRef *model)
| Retrieves the model object associated with the entity. More...
enum SUResult | SUEntityGetParentEntities (SUEntityRef entity, SUEntitiesRef *entities)
| Retrieves the entities object which contains the entity. More...

## Detailed Description

A dimension entity reference.

Since
  SketchUp 2017, API 5.0

## Friends And Related Function Documentation

SUDimensionRef SUDimensionFromDrawingElement | ( | SUDrawingElementRef | element | ) |
| related

Converts from an SUDrawingElementRef to an SUDimensionRef. This is essentially a downcast operation so the given SUDrawingElementRef must be convertible to an SUDimensionRef.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | element | The given drawing element reference.

Returns
  - The converted SUDimensionRef if the downcast operation succeeds
  - If not, the returned reference will be invalid

SUDimensionRef SUDimensionFromEntity | ( | SUEntityRef | entity | ) |
| related

Converts from an SUEntityRef to an SUDimensionRef. This is essentially a downcast operation so the given SUEntityRef must be convertible to an SUDimensionRef.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | entity | The given entity reference.

Returns
  - The converted SUDimensionRef if the downcast operation succeeds
  - If not, the returned reference will be invalid

enum SUResult SUDimensionGetArrowType | ( | SUDimensionRef | dimension,
|  | enum SUArrowType * | type
| ) |  |
| related

Retrieves an enum value indicating the dimension's arrow type.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [out] | type | The arrow type enum value retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if type is NULL

enum SUResult SUDimensionGetFont | ( | SUDimensionRef | dimension,
|  | SUFontRef * | font
| ) |  |
| related

Get the dimension's font reference.

Note
  The returned font reference may become invalid if another font is assigned to this dimension object later.

Since
  SketchUp 2019, API 7.0

Parameters

  [in] | dimension | The dimension object.
  [out] | font | The font retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if font is NULL

enum SUResult SUDimensionGetPlane | ( | SUDimensionRef | dimension,
|  | struct SUPlane3D * | plane
| ) |  |
| related

Retrieves the plane of a dimension object.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [out] | plane | The 3d plane retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if plane is NULL

enum SUResult SUDimensionGetText | ( | SUDimensionRef | dimension,
|  | SUStringRef * | text
| ) |  |
| related

Retrieves the text of a dimension object.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [out] | text | The name retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if text is NULL
  - SU_ERROR_INVALID_OUTPUT if text does not point to a valid SUStringRef object

enum SUResult SUDimensionGetText3D | ( | SUDimensionRef | dimension,
|  | bool * | is_text_3d
| ) |  |
| related

Retrieves a boolean indicating if the dimension text is 3D.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [out] | is_text_3d | The flag value retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if is_text_3d is NULL

enum SUResult SUDimensionGetType | ( | SUDimensionRef | dimension,
|  | enum SUDimensionType * | type
| ) |  |
| related

Retrieves an enum value indicating the dimension type (linear or radial).

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [out] | type | The dimension type enum value retrieved.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object
  - SU_ERROR_NULL_POINTER_OUTPUT if type is NULL

enum SUResult SUDimensionSetArrowType | ( | SUDimensionRef | dimension,
|  | enum SUArrowType | type
| ) |  |
| related

Sets the dimension's arrow type.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [in] | type | The arrow type to be set.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object
  - SU_ERROR_OUT_OF_RANGE if type is not a supported value

enum SUResult SUDimensionSetFont | ( | SUDimensionRef | dimension,
|  | SUFontRef | font
| ) |  |
| related

Sets the dimension's font from a font reference.

Since
  SketchUp 2019, API 7.0

Parameters

  [in] | dimension | The dimension object.
  [in] | font | The font to be set.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension or font is not a valid object
  - SU_ERROR_NULL_POINTER_INPUT if font is NULL

enum SUResult SUDimensionSetText | ( | SUDimensionRef | dimension,
|  | const char * | text
| ) |  |
| related

Sets the text of a dimension object.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [in] | text | The text to be set. Assumed to be UTF-8 encoded.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object
  - SU_ERROR_NULL_POINTER_INPUT if text is NULL

enum SUResult SUDimensionSetText3D | ( | SUDimensionRef | dimension,
|  | bool | is_text_3d
| ) |  |
| related

Sets a boolean indicating whether the dimension text is 3D.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The dimension object.
  [in] | is_text_3d | The flag to be set.

Returns
  - SU_ERROR_NONE on success
  - SU_ERROR_INVALID_INPUT if dimension is not a valid object

SUDrawingElementRef SUDimensionToDrawingElement | ( | SUDimensionRef | dimension | ) |
| related

Converts from an SUDimensionRef to an SUDrawingElementRef. This is essentially an upcast operation.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The given dimension reference.

Returns
  - The converted SUDrawingElementRef if dimension is a valid object
  - If not, the returned reference will be invalid

SUEntityRef SUDimensionToEntity | ( | SUDimensionRef | dimension | ) |
| related

Converts from an SUDimensionRef to an SUEntityRef. This is essentially an upcast operation.

Since
  SketchUp 2017, API 5.0

Parameters

  [in] | dimension | The given dimension reference.

Returns
  - The converted SUEntityRef if dimension is a valid object
  - If not, the returned reference will be invalid

The documentation for this struct was generated from the following files:

- SketchUpAPI/model/defs.h
- SketchUpAPI/model/dimension.h